%% Seminář 11
%% Úkol 1
% _Jak určíme návaznost Hermitovských kubik? Své tvrzení vyzkoušejte._ 
% 
% Určíme podle vektorů p1 první křivky a p0 křivky druhé.

t = linspace(0,1,100);

x10 = -2; y10 = 3;
P10 = [x10 y10];

x11 = 1;y11 = 5;
P11 = [x11, y11];

x20 = x11; y20 = y11; % Pro C0 i G0 musi byt body P11 a P20 shodne
P20 = [x20, y20];

x21 = 6; y21 = 2;
P21 = [x21, y21];

uhel10 = -61; 
uhel11 = 80; % Pro C1 i G1 musi byt uhel11 a uhel20 shodne 
uhel20 = 80; 
uhel21 = 159; 

velikost10 = 4;
velikost11 = 10; % Pro C1 musi byt shodne velikost11 a velikost20
velikost20 = 10;
velikost21 = 4;

p10 = velikost10 * [cosd(uhel10) sind(uhel10)];
p11 = velikost11 * [cosd(uhel11) sind(uhel11)];
p20 = velikost20 * [cosd(uhel20) sind(uhel20)];
p21 = velikost21 * [cosd(uhel21) sind(uhel21)];

pp10 = P10 + p10;
pp11 = P11 + p11;

X1 = (2*t.^3 - 3*t.^2 + 1)*P10(1) + (t.^3 - 2*t.^2 + t)*p10(1) + (-2*t.^3 + 3*t.^2) * P11(1) + (t.^3 - t.^2)*p11(1);
Y1 = (2*t.^3 - 3*t.^2 + 1)*P10(2) + (t.^3 - 2*t.^2 + t)*p10(2) + (-2*t.^3 + 3*t.^2) * P11(2) + (t.^3 - t.^2)*p11(2);

pp20 = P20 + p20;
pp21 = P21 + p21;

X2 = (2*t.^3 - 3*t.^2 + 1)*P20(1) + (t.^3 - 2*t.^2 + t)*p20(1) + (-2*t.^3 + 3*t.^2) * P21(1) + (t.^3 - t.^2)*p21(1);
Y2 = (2*t.^3 - 3*t.^2 + 1)*P20(2) + (t.^3 - 2*t.^2 + t)*p20(2) + (-2*t.^3 + 3*t.^2) * P21(2) + (t.^3 - t.^2)*p21(2);

figure, plot(X1,Y1,'-')
hold on
plot(X2,Y2,'-')
plot([x10 pp10(1)],[y10 pp10(2)],':', 'Color', [0.7 0.7 1])
plot([x11 pp11(1)],[y11 pp11(2)],':', 'Color', [0.7 0.7 1])
plot([x20 pp20(1)],[y20 pp20(2)],':', 'Color', [1 0.7 0.7])
plot([x21 pp21(1)],[y21 pp21(2)],':', 'Color', [1 0.7 0.7])
xlim([-5 10]);
ylim([-5 20]);

hold off
%% Úkol 2
% Naprogramujte funkci |B = bezier(t,P)| implementující naivní algoritmus pro 
% výpočet aproximační Beziérovy kubiky. Funkce pro zadané t a vektor 2 × 4 kontrolních 
% bodů (|P|) vrátí bod |B|. Pro výpočet kombinačního čísla můžete použít funkci 
% |nchoosek()|.
% 
% Pro následující kód byste měli dostat následující výsledek.

b = [];
P = [0 10 20 30;
    0 10 15 0];

for i = 0 : 0.1 : 1
    b = [b, bezier( i, P )];
end

figure,
plot(P(1,:), P(2,:));
hold on;
plot(b(1,:), b(2,:));
hold off
%% Úkol 3
% _Vyzkoušejte různé návaznosti Beziérových kubik._

p10 = [0;0];
p11 = [10;10];
p12 = [20;15];
p13 = [20;0];

p20 = p13; % Navaznost C0 a G0, pokud je shodny s p13
p21 = [20;-15]; % Navaznost G1 pokud je x-ova souradnice 20 a y mensi nez 0, C1 pokud je y-ova v absolutni hodnote rovna y souradnici p12
p22 = [30;-30];
p23 = [50;0];

P1 = [p10 p11 p12 p13];
P2 = [p20 p21 p22 p23];

B1 = [];
B2 = [];
for i = 0 : 0.05 : 1
    B1 = [B1 bezier(i, P1)];
    B2 = [B2 bezier(i, P2)];
end

figure,
plot(P1(1,:), P1(2,:),':', 'Color', [1 0.7 0.7]);
hold on;
plot(P2(1,:), P2(2,:),':', 'Color', [0.7 0.7 1]);

plot(B1(1,:), B1(2,:), 'Color', [0.8500 0.3250 0.0980]);
plot(B2(1,:), B2(2,:), 'Color', [0 0.4470 0.7410]);
hold off
%% Pomocné funkce

function B = bezier( t, P )
    B = [0, 0]';
    n = size(P, 2);
    for i = 1:n
        B = B + bpol(t, i - 1, n - 1) * P(:, i);
    end
end

function value = bpol(t, i, n)
    value = nchoosek(n, i) * t^i * (1 - t)^(n - i);
end